; +------------------------------------------------+
; | Calendar v1.01 - By Smay                       |  
; |                                                |
; |      ---------- AddEvent.mrc -----------       |
; | All data contained in this file is used to     |
; | Record an event entered by the user and save   |
; | it to a file so that the person can be         |
; | Reminded of important dates. All aliases       |
; | except for AddEvent are local aliases only     |
; |                                                |
; | AddEvent <Month> <Day> <Year> [Edit] [Line #]  |
; +------------------------------------------------+

alias AddEvent {
  set %CAdd.inisection $1 $+ $2 $+ $3
  window -Cdpk0 +lt @Add -1 -1 495 360
  titlebar @Add an event to the calendar
  DrawBG @Add 495 360
  drawtext -nro @Add $rgb(255,255,255) "Times New Roman" 18 130 10 Add an Event to the Calendar
  drawrect -nr @Add $rgb(hilight) 1 247 34 4 245
  drawrect -nr @Add $rgb(shadow) 1 247 34 4 245
  
  drawtext -nro @Add $rgb(255,255,255) "Times New Roman" 18 42 35 Set Event Description
  
  if ($4 != $null) {
    set %CAdd.editing $true 
    set %CAdd.eventlinenum $5
    var %CAdd.eventline = $read( [ %Calendar.directory ] $+ events.dat,l,$5)
    set %CAdd.eventtitle $gettok(%CAdd.eventline,1,166)
    editbox @Add 18 70 210 25 $gettok(%CAdd.eventtitle,1,166)
    EditBox @Add 18 108 210 170
    if ($numtok(%CAdd.eventline,166) > 2) {
      set %CAdd.description $gettok(%CAdd.eventline,2,166)
      WriteInDescription
    }
    set %CAdd.hrs $gettok($gettok(%CAdd.eventline,$numtok(%CAdd.eventline,166),166),1,58)
    set %CAdd.mins $gettok($gettok(%CAdd.eventline,$numtok(%CAdd.eventline,166),166),2,58)
    set %CAdd.tod $gettok($gettok(%CAdd.eventline,$numtok(%CAdd.eventline,166),166),3,58)
  }
  else {
    editbox @Add 18 70 210 25 Click Here To Change Title
    EditBox @Add 18 108 210 170
    drawtext -nr @Add $rgb(0,0,0) "Times New Roman" 14 70 160 Click Here To Add
    drawtext -nr @Add $rgb(0,0,0) "Times New Roman" 14 120 180 A
    drawtext -nr @Add $rgb(0,0,0) "Times New Roman" 14 55 200 Description of the Event
    set %CAdd.hrs 00
    set %CAdd.mins 00
    set %CAdd.tod AM
  }
  drawbutton @Add 160 290 80 25 Add Event
  drawbutton @Add 258 290 80 25 Cancel
  
  drawtext -nor @Add $rgb(255,255,255) "Times New Roman" 18 310 35 Set Event Time
  Clock @Add 310 70
  AddHands %CAdd.hrs %CAdd.mins @Add 310 70
  if (%CAdd.hrs == 00) { editbox @Add 315 210 30 17 12 }
  else { editbox @Add 315 210 30 17 %CAdd.hrs }
  editbox @Add 345 210 30 17 %CAdd.mins
  editbox @Add 375 210 30 17 %CAdd.tod
  drawpic -ntc @Add $rgb(0,0,0) 407 210 %Calendar.directory $+ arrows.bmp
  drawrect @Add
}

; --------------------------------------------
; Local alias to fit the description of an
; event into the text area given. Makes sure 
; No word extends the boundaries of the box.
; --------------------------------------------

alias -l WriteInDescription {
  EditBox @Add 18 108 210 170
  if ($width(%CAdd.description,Times New Roman,14,1,1) > 210) {
    var %CAdd.descriptiontoks $numtok(%CAdd.description,32)
    var %CAdd.counter 1
    var %CAdd.ypos 110
    var %CAdd.lengthcounter 1
    while (%CAdd.counter <= %CAdd.descriptiontoks) {
      set %CAdd.currentword $gettok(%CAdd.description,%CAdd.counter,32)
      var %CAdd.lengthcounter $calc(%CAdd.lengthcounter + $width(%CAdd.currentword,Times New Roman,14,1,1) + 4)
      if (%CAdd.lengthcounter > 210) {
        drawtext -r @Add $rgb(0,0,0) "Times New Roman" 16 19 %CAdd.ypos %CAdd.limiteddesc
        var %CAdd.lengthcounter $calc(1 + $width(%CAdd.currentword,Times New Roman,14,1,1))
        var %CAdd.limiteddesc %CAdd.currentword
        var %CAdd.ypos $calc(%CAdd.ypos + 14)
      }
      else {
        var %CAdd.limiteddesc [ [ %CAdd.limiteddesc ] %CAdd.currentword ]
      }
      inc %CAdd.counter
      if (%CAdd.ypos > 270) { return }
    }
    drawtext -r @Add $rgb(0,0,0) "Times New Roman" 14 19 %CAdd.ypos %CAdd.limiteddesc
  }
  else {
    if (%CAdd.description != $null) { drawtext -r @Add $rgb(0,0,0) "Times New Roman" 14 19 110 %CAdd.description }
  }
}

; ------------------------------------
; Local alias to write any events
; entered into two text files. One
; File has headings for each date
; So that it can be determined whether
; or not to append to a certain place
; in the other text file, which stores
; the actual event.
; ------------------------------------

alias -l SaveEvent {
  CheckIfBusy %CAdd.inisection
  if (%CAdd.busy == $true) {
    FindEventHeader %CAdd.inisection
    set %CAdd.eventlinenum $calc(%CAdd.eventlinenum + 1)
    write -il $+ %CAdd.eventlinenum [ %Calendar.directory ] $+ events.dat %CAdd.eventtitle $+ $chr(166) $+ %CAdd.description $+ $chr(166) $+ %CAdd.hrs $+ $chr(58) $+ %CAdd.mins $+ $chr(58) $+ %CAdd.tod
  }
  else {
    write [ %Calendar.directory ] $+ busydays.dat %CAdd.inisection
    write [ %Calendar.directory ] $+ events.dat $chr(171) $+ %CAdd.inisection
    write [ %Calendar.directory ] $+ events.dat %CAdd.eventtitle $+ $chr(166) $+ %CAdd.description $+ $chr(166) $+ %CAdd.hrs $+ $chr(58) $+ %CAdd.mins $+ $chr(58) $+ %CAdd.tod
  }
  unset %CAdd.*
  .timerClose -m 1 20 window -c @Add
  .timerUpdate -m 1 21 ReDrawWindow
  .timerUpdate1 -m 1 22 UpdateEventTimers
  .timerWindowA -m 1 23 window -a @Calendar
}

; ------------------------------------
; Local alias to re-save an event with
; new information
; ------------------------------------

alias -l ReSaveEvent {
  write -l $+ %CAdd.eventlinenum [ %Calendar.directory ] $+ events.dat %CAdd.eventtitle $+ $chr(166) $+ %CAdd.description $+ $chr(166) $+ %CAdd.hrs $+ $chr(58) $+ %CAdd.mins $+ $chr(58) $+ %CAdd.tod
  unset %CAdd.*
  .timerClose -m 1 20 window -c @Add
  .timerUpdate -m 1 21 ReDrawWindow
  .timerUpdate1 -m 1 22 UpdateEventTimers
  .timerWindowA -m 1 23 window -a @Calendar
}

; ----------------------------------
; A local alias that checks to see
; if there is already an event for
; the day the new event is being
; added.
; ----------------------------------

alias -l CheckIfBusy {
  var %CAdd.counter 1
  while (%CAdd.counter <= $lines( [ %Calendar.directory $+ busydays.dat ] )) {
    if ($read( [ %Calendar.directory ] $+ busydays.dat,l,%CAdd.counter)  == $1) { 
      set %CAdd.busy $true
      return
    }
    inc %CAdd.counter
  }
}

; ----------------------------------
; A local alias that checks to see
; where the events for a certain day
; are saved.
; ----------------------------------

alias -l FindEventHeader {
  var %CAdd.counter 1
  while (%CAdd.counter <= $lines( [ %Calendar.directory $+ events.dat ] )) {
    if ($1 isin $read( [ %Calendar.directory ] $+ events.dat,l,%CAdd.counter)) { 
      set %CAdd.eventlinenum %CAdd.counter
      return
    }
    inc %CAdd.counter
  }
}

; --------------
;   Mouse Menu
; -------------- 
  
menu @Add {
  sclick: {
    if ($inrect($mouse.x,$mouse.y,258,290,80,25) == $true) {
      DrawButtonDown @Add 258 290 80 25 Cancel
      set %CAdd.clicked Cancel
    }
    elseif ($inrect($mouse.x,$mouse.y,160,290,80,25) == $true) {
      DrawButtonDown @Add 160 290 80 25 Add Event
      set %CAdd.clicked Install
    }
    elseif ($inrect($mouse.x,$mouse.y,315,210,30,17) == $true) {
      set %CAdd.clicked Hours
    }
    elseif ($inrect($mouse.x,$mouse.y,345,210,30,17) == $true) {
      set %CAdd.clicked Minutes
    }
    elseif ($inrect($mouse.x,$mouse.y,375,210,30,17) == $true) {
      set %CAdd.clicked TimeOfDay
    }
    elseif ($inrect($mouse.x,$mouse.y,407,209,14,8) == $true) {
      set %CAdd.clicked UpArrow
    }
    elseif ($inrect($mouse.x,$mouse.y,407,218,14,8) == $true) {
      set %CAdd.clicked DownArrow
    }
    elseif ($inrect($mouse.x,$mouse.y,18,70,210,25) == $true) {
      set %CAdd.clicked TitleBox
    }
    elseif ($inrect($mouse.x,$mouse.y,18,108,210,170) == $true) {
      set %CAdd.clicked Description
    }
    else { }
  }
  uclick: {
    if (($inrect($mouse.x,$mouse.y,258,290,80,25) == $true) && (%CAdd.clicked == Cancel)) {
      DrawButton @Add 258 290 80 25 Cancel
      unset %CAdd* %CalMenu.*
      .timerWindowA -m 1 20 window -a @Calendar     
      window -c @Add
    }
    elseif (($inrect($mouse.x,$mouse.y,160,290,80,25) == $true) && (%CAdd.clicked == Install)) {
      if (%CAdd.editing == $true) { ReSaveEvent }
      elseif (%CAdd.eventtitle != $null) { SaveEvent }
      else { editbox @Add 18 70 210 25 You Must Enter A Title }
      DrawButton @Add 160 290 80 25 Add Event
    }
    elseif (($inrect($mouse.x,$mouse.y,315,210,30,17) == $true) && (%CAdd.clicked == Hours)) {
      set %CAdd.selectedbox Hours
      if (%CAdd.hrs == 00) { SelectTime @Add 315 210 30 17 12 }
      else { SelectTime @Add 315 210 30 17 %CAdd.hrs }
      editbox @Add 345 210 30 17 %CAdd.mins
      editbox @Add 375 210 30 17 %CAdd.tod
    }
    elseif (($inrect($mouse.x,$mouse.y,345,210,30,17) == $true) && (%CAdd.clicked == Minutes)) {
      set %CAdd.selectedbox Minutes
      SelectTime @Add 345 210 30 17 %CAdd.mins
      if (%CAdd.hrs == 00) { editbox @Add 315 210 30 17 12 }
      else { editbox @Add 315 210 30 17 %CAdd.hrs }
      editbox @Add 375 210 30 17 %CAdd.tod
    }
    elseif (($inrect($mouse.x,$mouse.y,375,210,30,17) == $true) && (%CAdd.clicked == TimeOfDay)) {
      set %CAdd.selectedbox TimeofDay
      SelectTime @Add 375 210 30 17 %CAdd.tod
      if (%CAdd.hrs == 00) { editbox @Add 315 210 30 17 12 }
      else { editbox @Add 315 210 30 17 %CAdd.hrs }
      editbox @Add 345 210 30 17 %CAdd.mins
    }
    elseif (($inrect($mouse.x,$mouse.y,407,209,14,8) == $true) && (%CAdd.clicked == UpArrow) && (%CAdd.selectedbox != $null)) {
      if (%CAdd.selectedbox == Hours) {
        if (%CAdd.hrs == 11) {
          set %CAdd.hrs 0 
          SelectTime @Add 315 210 30 17 12 
        }
        else { 
          inc %CAdd.hrs
          if ($len(%CAdd.hrs) == 1) { set %CAdd.hrs [ 0 [ $+ [ %CAdd.hrs ] ] ] }
          SelectTime @Add 315 210 30 17 %CAdd.hrs
        }
        ClearClock @Add 310 70
        AddHands %CAdd.hrs %CAdd.mins @Add 310 70
      }
      if (%CAdd.selectedbox == Minutes) {
        if (%CAdd.mins == 59) { set %CAdd.mins 00 }
        else { inc %CAdd.mins }
        if ($len(%CAdd.mins) == 1) { set %CAdd.mins [ 0 [ $+ [ %CAdd.mins ] ] ] }
        SelectTime @Add 345 210 30 17 %CAdd.mins
        ClearClock @Add 310 70
        AddHands %CAdd.hrs %CAdd.mins @Add 310 70
      }
      if (%CAdd.selectedbox == TimeOfDay) {
        if (%CAdd.tod == AM) { set %CAdd.tod PM }
        else { set %CAdd.tod AM }
        SelectTime @Add 375 210 30 17 %CAdd.tod
      }  
    }
    elseif (($inrect($mouse.x,$mouse.y,407,218,14,8) == $true) && (%CAdd.clicked == DownArrow) && (%CAdd.selectedbox != $null)) {
      if (%CAdd.selectedbox == Hours) {
        if (%CAdd.hrs == 0) {
          set %CAdd.hrs 11 
          SelectTime @Add 315 210 30 17 %CAdd.hrs 
        }
        elseif (%CAdd.hrs == 1) {
          set %CAdd.hrs 0
          SelectTime @Add 315 210 30 17 12
        }
        else { 
          dec %CAdd.hrs
          if ($len(%CAdd.hrs) == 1) { set %CAdd.hrs [ 0 [ $+ [ %CAdd.hrs ] ] ] }
          SelectTime @Add 315 210 30 17 %CAdd.hrs
        }
        ClearClock @Add 310 70
        AddHands %CAdd.hrs %CAdd.mins @Add 310 70
      }
      if (%CAdd.selectedbox == Minutes) {
        if (%CAdd.mins == 00) { set %CAdd.mins 59 }
        else { dec %CAdd.mins }
        if ($len(%CAdd.mins) == 1) { set %CAdd.mins [ 0 [ $+ [ %CAdd.mins ] ] ] }        
        SelectTime @Add 345 210 30 17 %CAdd.mins
        ClearClock @Add 310 70
        AddHands %CAdd.hrs %CAdd.mins @Add 310 70
      }
      if (%CAdd.selectedbox == TimeOfDay) {
        if (%CAdd.tod == AM) { set %CAdd.tod PM }
        else { set %CAdd.tod AM }
        SelectTime @Add 375 210 30 17 %CAdd.tod
      }  
    }
    elseif (($inrect($mouse.x,$mouse.y,18,70,210,25) == $true) && (%CAdd.clicked == TitleBox)) {
      var %CAdd.oldeventtitle %CAdd.eventtitle
      if (%CAdd.eventtitle != $null) { set %CAdd.eventtitle $input(What is the Title of this Event?,33,Event Title,%CAdd.eventtitle) }
      else { set %CAdd.eventtitle $input(What is the Title of this Event?,1,Event Title) }
      if (%CAdd.eventtitle != $null) { editbox @Add 18 70 210 25 %CAdd.eventtitle }
      else { 
        set %CAdd.eventtitle %CAdd.oldeventtitle
        editbox @Add 18 70 210 25 %CAdd.eventtitle 
      }
    }
    elseif (($inrect($mouse.x,$mouse.y,18,108,210,170) == $true) && (%CAdd.clicked == Description)) {
      var %CAdd.olddescription %CAdd.description
      if (%CAdd.description != $null) { set %CAdd.description $input(Enter a description of the event,1,Event Description,%CAdd.description) }
      else { set %CAdd.description $input(Enter a description of the event,1,Event Description) }
      if (%CAdd.description != $null) { WriteInDescription }
      else {
        set %CAdd.description %CAdd.olddescription
        WriteInDescription
      }
    }
    else {
      unset %CAdd.selectedbox
      if (%CAdd.hrs == 00) { editbox @Add 315 210 30 17 12 }
      else { editbox @Add 315 210 30 17 %CAdd.hrs }      
      editbox @Add 345 210 30 17 %CAdd.mins
      editbox @Add 375 210 30 17 %CAdd.tod
      DrawButton @Add 258 290 80 25 Cancel 
      DrawButton @Add 160 290 80 25 Add Event
    }
  }
}