
; -------------------------------------
; Load events for the rest of the day
; and update when needed.
; -------------------------------------
on 1:connect: { UpdateEventTimers }

alias Calendar {
  unset %c.*
  set %c.CurrentMonth $gettok($fulldate,2,32)
  set %c.CurrentYear $gettok($fulldate,5,32)

  window -Cdpk0 +nlt @Calendar -1 -1 675 660
  titlebar @Calendar v1.01 - :: Teens Script ::
  CreateCalendar
}

; --------------------------------------------------------------------------------------------
; CreateCalendar creates the correct number of squares according to what info is given to it.
; --------------------------------------------------------------------------------------------

alias -l CreateCalendar {
  DrawBG @Calendar 675 660
  DayOfWeek 1 %c.CurrentMonth %c.CurrentYear
  set %c.CurrentMonth $GetMonthName(%c.CurrentMonth)

  set %c.prev.x $int($calc(((655/2) - ($width(%c.CurrentMonth,Times New Roman,28,1,0) / 2)) - 37))
  set %c.next.x $int($calc(((655/2) + ($width(%c.CurrentMonth,Times New Roman,28,1,0) / 2)) + 27))

  drawpic -ntc @Calendar $rgb(0,0,0) $int($calc(((655/2) - ($width(%c.CurrentMonth,Times New Roman,28,1,0) / 2)) - 37)) 18 %Calendar.directory $+ previous.bmp
  drawtext -nhro @Calendar $rgb(255,255,255) "Times New Roman" 28 $int($calc(((655/2) - ($width(%c.CurrentMonth,Times New Roman,32,1,0) / 2)) + 8)) 10 %c.CurrentMonth
  drawpic -ntc @Calendar $rgb(0,0,0) $int($calc(((655/2) + ($width(%c.CurrentMonth,Times New Roman,28,1,0) / 2)) + 27)) 18 %Calendar.directory $+ next.bmp
  drawtext -nhr @Calendar $rgb(255,255,255) "Times New Roman" 10 630 5 %c.CurrentYear

  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 27 50 Sunday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 122 50 Monday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 211 50 Tuesday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 293 50 Wednesday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 394 50 Thursday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 498 50 Friday
  drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 15 579 50 Saturday

  set %c.DOWCounter 1
  set %c.xcoord 10
  set %c.ycoord 70
  set %c.DayNum 1
  set %c.FirstSquare $true

  ; Draw in blank squares if the month doesn't start on a Sunday
  while (%c.DOWCounter < %c.DayOfWeekNum) {
    DrawBlankSquare %c.xcoord %c.ycoord 88 88
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DOWCounter
  }

  while (%c.DayNum <= %c.DaysInMonth) {
    if (%c.DOWCounter > 7) {
      set %c.DOWCounter 1
      set %c.xcoord 10
      set %c.ycoord $calc(%c.ycoord + 93)
    }
    DrawSquare %c.xcoord %c.ycoord 88 88 %c.DayNum
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DayNum
    inc %c.DOWCounter
  }

  ; ---------------------------------------------------------------------
  ; Write in the title of any event scheduled for a day in this month...
  ; ----------------------------------------------------------------------

  set %c.DOWCounter 1
  set %c.xcoord 10
  set %c.ycoord 70
  set %c.DayNum 1

  ; Ignore all of the blank squares in the month
  while (%c.DOWCounter < %c.DayOfWeekNum) {
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DOWCounter
  }
  while (%c.DayNum <= %c.DaysInMonth) {
    if (%c.DOWCounter > 7) {
      set %c.DOWCounter 1
      set %c.xcoord 10
      set %c.ycoord $calc(%c.ycoord + 93)
    }
    CheckIfEventExists
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DayNum
    inc %c.DOWCounter
  }

  drawdot @Calendar
  unset %c.currentlineinfile %c.counter %c.file %c.ypostext %c.xpostext %c.linetosearch %c.ypostextlimit
  unset %c.xcoord %c.ycoord %c.DayNum %c.DOWCounter
}

; -------------------------------------------
; DrawSquare accepts paramaters as follows:
; DrawSquare X Y W H Day#
; -------------------------------------------

alias -l DrawSquare {
  drawrect -nhrf @Calendar $rgb(255,255,255) 1 $1 $2 $3 $4
  if (%c.DayNum < 10) { drawtext -nhro @Calendar $rgb(0,0,0) $calc(%c.xcoord + 77) $calc(%c.ycoord + 3) $5 }
  else { drawtext -nhro @Calendar $rgb(0,0,0) $calc(%c.xcoord + 70) $calc(%c.ycoord + 3) $5 }
}

; -------------------------------------------
; DrawSquare accepts paramaters as follows:
; DrawSquare X Y W H
; -------------------------------------------

alias -l DrawBlankSquare { 
  drawrect -nhrf @Calendar $rgb(255,255,255) 1 $1 $2 $3 $4 
}

; -------------------------------------------
; ReDrawWindow recreates the calendar window
; Whenever someone changes the current month.
; -------------------------------------------

alias ReDrawWindow {
  unset %CalMenu.menuopen
  CreateCalendar
}

; -------------------------------------
; Check if an event exists for the 
; Current date to determine whether or
; Not any text needs to be added
; -------------------------------------

alias -l CheckIfEventExists {
  set %c.linetosearch %c.CurrentMonth $+ %c.DayNum $+ %c.CurrentYear
  set %c.file %Calendar.directory $+ busydays.dat
  set %c.counter 1
  while (%c.counter <= $lines(%c.file)) {
    set %c.currentlineinfile $read(%c.file,l,%c.counter)
    if (%c.currentlineinfile == %c.linetosearch) { WriteEventToCalendar %c.linetosearch }
    inc %c.counter
  }
  unset %c.counter %c.file %c.linetosearch
}

; ----------------------------------
; An event has been found to exist.
; This alias writes it into the
; Calendar under the appropriate
; date.
; ----------------------------------

alias -l WriteEventToCalendar {
  unset %c.datefound
  set %c.linetosearch $chr(171) $+ $1
  set %c.file %Calendar.directory $+ events.dat
  set %c.ypostext $calc(%c.ycoord + 16)
  set %c.xpostext $calc(%c.xcoord + 2)
  set %c.ypostextlimit $calc(%c.ycoord + 70)
  set %c.counter 1
  while (%c.counter <= $lines(%c.file)) {
    set %c.currentlineinfile $read(%c.file,l,%c.counter)
    if (%c.datefound == $true) {
      if ($chr(171) isin %c.currentlineinfile) {
        set %c.datefound $false
        return
      }
      else {
        set %c.eventtitle $gettok(%c.currentlineinfile ,1,166)
        drawtext -hcr @Calendar $rgb(0,0,0) "Times New Roman" 9 %c.xpostext %c.ypostext 86 12 %c.eventtitle
        set %c.ypostext $calc(%c.ypostext + 12)
        if (%c.ypostext > %c.ypostextlimit) {
          drawtext -hcr @Calendar $rgb(0,0,0) "Times New Roman" 9 %c.xpostext %c.ypostext 86 12 . . . . .
          return
        }
      }
    }
    if (%c.currentlineinfile == %c.linetosearch) { set %c.datefound $true }
    inc %c.counter  
  }      
}

; -----------------------------
; Set timers to go off for
; scheduled events
; -----------------------------
alias UpdateEventTimers {
  .timerevent* off
  set %c.linetosearch $GetMonthName($gettok($fulldate,2,32)) $+ $gettok($fulldate,3,32) $+ $gettok($fulldate,5,32)
  var %c.file = %Calendar.directory $+ busydays.dat
  var %c.counter = 1
  while (%c.counter <= $lines(%c.file)) {
    var %c.currentlineinfile = $read(%c.file,l,%c.counter)
    if (%c.currentlineinfile == %c.linetosearch) { 
      var %c.maketimer = $true
      break
    }
    inc %c.counter
  }

  ; Make the timers for all events for this day. Also make a timer to update at the end of the day

  if (%c.utimerstarted != $true) {
    .timerUpdateWaitThing -o 1 65 .timerUpdateTimers 00:00 1 1 UpdateEventTimers
    set %c.utimerstarted $true 
    .timerUnsetTimerVar -o 1 65 unset %c.utimerstarted
  }
  if (%c.maketimer == $true) {
    set %c.linetosearch $chr(171) $+ %c.linetosearch
    var %c.file = %Calendar.directory $+ events.dat
    var %c.counter = 1
    while (%c.counter <= $lines(%c.file)) {
      var %c.currentlineinfile = $read(%c.file,l,%c.counter)
      if (%c.founddate == $true) {
        if ($chr(171) isin %c.currentlineinfile) { var %c.founddate = $false | return | }
        else {
          var %c.timeofevent = $gettok(%c.currentlineinfile,$numtok(%c.currentlineinfile,166),166)
          if ($gettok(%c.timeofevent,3,58) == PM) { var %c.timeofevent = $calc($gettok(%c.timeofevent,1,58) + 12) $+ $chr(58) $+ $gettok(%c.timeofevent,2,58) }
          if ($numtok(%c.currentlineinfile,166) < 3) { .timerEvent $+ %c.counter -o %c.timeofevent 1 1 EventNotification $gettok(%c.currentlineinfile,1,166) $+ $chr(166) $+ $chr(32) }
          else { .timerEvent $+ %c.counter -o %c.timeofevent 1 1 EventNotification $gettok(%c.currentlineinfile,1,166) $+ $chr(166) $+ $gettok(%c.currentlineinfile,2,166) }
        }
      }
      if (%c.currentlineinfile == %c.linetosearch) { var %c.founddate = $true }
      inc %c.counter  
    }
  }
  unset %c.linetosearch     
}

; ---------------------------------------------
; Screen that pops up to notify user that an
; Event has occurred
; ---------------------------------------------
alias EventNotification {
  dialog -ma { Events Events }
  did -a Events 3 $gettok($1-,1,166) $crlf $crlf
  if (($chr(58) isin $gettok($1-,2,166)) && (($gettok($gettok($1-,2,166),3,58) == AM) || ($gettok($gettok($1-,2,166),3,58) == PM))) {}
  else { did -a Events 3 $gettok($1-,2,166) }
}

; ------------------------------------------------
; Highlight one of the date/non-date squares when 
; the mouse moves over it
; HighlightSquare accepts parameters as follows:
; HighlightSquare xcoord ycoord
; ------------------------------------------------

alias -l HighlightSquare {
  drawrect -rh @Calendar $rgb(255,255,0) 2 $1 $2 88 88
  if (%c.FirstSquare == $false) { .timer1 -m 1 1 UnHighlightSquare %c.PreviousSquare }
}

alias -l UnHighlightSquare {
  set %c.DOWCounter 1
  set %c.counter 1
  set %c.xcoord 10
  set %c.ycoord 70

  while (%c.counter < $1) {
    if (%c.DOWCounter > 7) {
      set %c.DOWCounter 1
      set %c.xcoord 10
      set %c.ycoord $calc(%c.ycoord + 93)
    }
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.counter
    inc %c.DOWCounter
  }
  drawrect -rh @Calendar $rgb(255,255,255) 2 $calc(%c.xcoord - 93) %c.ycoord 88 88
}

; ------------------------------------------------
; Check to see if a date square was clicked.
; If so, hilight it, and unhilight the previously
; hilighted square
; ------------------------------------------------
alias -l DoHilightCheck {
  set %c.DOWCounter 1
  set %c.xcoord 10
  set %c.ycoord 70
  set %c.DayNum 1

  while (%c.DOWCounter < %c.DayOfWeekNum) {        
    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DOWCounter
  }

  while (%c.DayNum <= %c.DaysInMonth) {
    if (%c.DOWCounter > 7) {
      set %c.DOWCounter 1
      set %c.xcoord 10
      set %c.ycoord $calc(%c.ycoord + 93)
    }

    if ($inrect($mouse.x,$mouse.y,%c.xcoord,%c.ycoord,88,88) == $true) {
      HighlightSquare %c.xcoord %c.ycoord
      set %c.PreviousSquare $calc(%c.DayNum + %c.DayOfWeekNum)
      set %c.FirstSquare $false
      break
    }

    set %c.xcoord $calc(%c.xcoord + 93)
    inc %c.DayNum
    inc %c.DOWCounter
  }
}

; -------------------------------------------------
; Create the menu when Shift + Left Click is done
; from within the Calendar window
; -------------------------------------------------
alias -l BuildMenu {
  drawrect -nhrf @Calendar $rgb(face) 1 $calc($1 + 1) $calc($2 + 1) 88 73
  drawline -nhr @Calendar $rgb(hilight) 1 $1 $calc($2 + 75) $1 $2 $calc($1 + 90) $2
  drawline -nhr @Calendar $rgb(shadow) 1 $1 $calc($2 + 74) $calc($1 + 89) $calc($2 + 74) $calc($1 + 89) $2
  drawtext -nhr @Calendar $rgb(0,0,0) "Comic Sans MS" 13 $calc($1 + 1) $calc($2 + 1) Edit Event
  drawtext -nhr @Calendar $rgb(0,0,0) "Comic Sans MS" 13 $calc($1 + 1) $calc($2 + 19) Delete Event
  drawtext -nhr @Calendar $rgb(0,0,0) "Comic Sans MS" 13 $calc($1 + 1) $calc($2 + 37) View Details
  drawtext -nhr @Calendar $rgb(0,0,0) "Comic Sans MS" 13 $calc($1 + 1) $calc($2 + 55) Add Event
  set %CalMenu.menuopen $true
}

alias -l HighlightMenuItem {
  var %CalMenu.item2y = $calc(%CalMenu.menuy + 19)
  var %CalMenu.item3y = $calc(%CalMenu.menuy + 37)
  var %CalMenu.item4y = $calc(%CalMenu.menuy + 55)

  if ($inrect(%CalMenu.menux,$1,%CalMenu.menux,%CalMenu.menuy,90,18) == $true) {
    BuildMenu %CalMenu.menux %CalMenu.menuy
    drawrect -nhrf @Calendar $rgb(0,0,128) 1 $calc(%CalMenu.menux + 1) $calc(%CalMenu.menuy + 1) 88 18
    drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 13 $calc(%CalMenu.menux + 1) $calc(%CalMenu.menuy + 1) Edit Event
    drawrect @Calendar
  }
  elseif ($inrect(%CalMenu.menux,$1,%CalMenu.menux,%CalMenu.item2y,90,18) == $true) {
    BuildMenu %CalMenu.menux %CalMenu.menuy
    drawrect -nhrf @Calendar $rgb(0,0,128) 1 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item2y + 1) 88 18
    drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 13 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item2y + 1) Delete Event
    drawrect @Calendar
  }
  elseif ($inrect(%CalMenu.menux,$1,%CalMenu.menux,%CalMenu.item3y,90,18) == $true) {
    BuildMenu %CalMenu.menux %CalMenu.menuy
    drawrect -nhrf @Calendar $rgb(0,0,128) 1 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item3y + 1) 88 18
    drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 13 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item3y + 1) View Details
    drawrect @Calendar
  }
  elseif ($inrect(%CalMenu.menux,$1,%CalMenu.menux,%CalMenu.item4y,90,18) == $true) {
    BuildMenu %CalMenu.menux %CalMenu.menuy
    drawrect -nhrf @Calendar $rgb(0,0,128) 1 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item4y + 1) 88 18
    drawtext -nhr @Calendar $rgb(255,255,255) "Comic Sans MS" 13 $calc(%CalMenu.menux + 1) $calc(%CalMenu.item4y + 1) Add Event
    drawrect @Calendar
  }
  else { BuildMenu %CalMenu.menux %CalMenu.menuy }
}


; --------------------------------------------------
; Dialog to notify a person when an event happens
; --------------------------------------------------
dialog Events {
  title "An Event Has Occured"
  size -1 -1 200 200
  edit "", 3, 3 3 194 165, read,center,multi,vsbar,autovs
  button "Ok", 1, 53 172 85 25, ok
}  


; ---------------------------------------------------
; MOUSE EVENTS
; The following code reads for mouse events and acts 
; Appropriately depending on what was done/clicked.
; ---------------------------------------------------
menu @Calendar {
  mouse: {
    if (%CalMenu.menuopen == $true) {
      if ($inrect($mouse.x,$mouse.y,%CalMenu.menux,%CalMenu.menuy,90,75) == $true) { HighlightMenuItem $mouse.y }
    }
  }
  sclick: {
    if ($inrect($mouse.x,$mouse.y,%c.prev.x,18,20,20) == $true) {
      set %c.CurrentMonth [ %c.PrevMonth ]
      if (%c.CurrentMonth == Dec) { dec %c.CurrentYear }
      ReDrawWindow
    }
    elseif ($inrect($mouse.x,$mouse.y,%c.next.x,18,20,20) == $true) {
      set %c.CurrentMonth [ %c.NextMonth ]
      if (%c.CurrentMonth == Jan) { inc %c.CurrentYear }
      ReDrawWindow
    }
    elseif ($inrect($mouse.x,$mouse.y,10,70,655,600) == $true) {
      ; ----------------------------------------------
      ; See if a menu item was clicked. This is here 
      ; so the day stays hilighted.
      ; ----------------------------------------------
      if ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 1),90,18)) {
        EventManager Edit %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 19),90,18)) {
        EventManager Delete %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 37),90,18)) {
        EventManager View %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 55),90,18)) {
        AddEvent %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }

      DoHilightCheck

      ; ----------------------------------------------------
      ; If the person holds down shift and clicks. 
      ; Menu appears, and redraw highlight around selected
      ; square. Only does this if the person clicked on a
      ; date
      ; ----------------------------------------------------
      if ($mouse.key & 4) {
        if ((%c.DayNum <= %c.DaysInMonth) && (%c.DayNum != 0)) {
          if ($calc($mouse.x + 90) >= 675) { set %CalMenu.menux $calc($mouse.x - 90) }
          else { set %CalMenu.menux $mouse.x }
          set %CalMenu.menuy $mouse.y
          set %CalMenu.datecreated %c.DayNum
          ReDrawWindow
          DoHilightCheck
          BuildMenu %CalMenu.menux %CalMenu.menuy
          drawdot @Calendar
        }
      }
      elseif (($inrect($mouse.x,$mouse.y,1,1,674,659)) && ($inrect($mouse.x,$mouse.y,%CalMenu.menux,%CalMenu.menuy,90,75) == $false)) {
        unset %CalMenu.*
        ReDrawWindow
        DoHilightCheck
      }
    }
  }
  dclick: { 
    if ($inrect($mouse.x,$mouse.y,10,70,655,600) == $true) {
      set %c.DOWCounter 1
      set %c.xcoord 10
      set %c.ycoord 70
      set %c.DayNum 1

      while (%c.DOWCounter < %c.DayOfWeekNum) {

        ; If statement to check if you clicked anywhere inside a blank white date square.
        if ($inrect($mouse.x,$mouse.y,%c.xcoord,%c.ycoord,88,88) == $true) { }
        set %c.xcoord $calc(%c.xcoord + 93)
        inc %c.DOWCounter
      }

      while (%c.DayNum <= %c.DaysInMonth) {
        if (%c.DOWCounter > 7) {
          set %c.DOWCounter 1
          set %c.xcoord 10
          set %c.ycoord $calc(%c.ycoord + 93)
        }

        ; If statement to see if you clicked a date square. The date of the square you clicked on is
        ; %CurrentMonth %DayNum $+ , %CurrentYear
        if ($inrect($mouse.x,$mouse.y,%c.xcoord,%c.ycoord,88,88) == $true) {
          AddEvent %c.CurrentMonth %c.DayNum %c.CurrentYear
        }
        set %c.xcoord $calc(%c.xcoord + 93)
        inc %c.DayNum
        inc %c.DOWCounter
      }
    }
  }
  rclick: {
    if ($inrect($mouse.x,$mouse.y,10,70,655,600) == $true) {
      ; ----------------------------------------------
      ; See if a menu item was clicked. This is here 
      ; so the day stays hilighted.
      ; ----------------------------------------------
      if ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 1),90,18)) {
        EventManager Edit %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 19),90,18)) {
        EventManager Delete %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 37),90,18)) {
        EventManager View %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }
      elseif ($inrect($mouse.x,$mouse.y,%CalMenu.menux,$calc(%CalMenu.menuy + 55),90,18)) {
        AddEvent %c.CurrentMonth %CalMenu.datecreated %c.CurrentYear
        .timerReDraw -m 1 10 ReDrawWindow
        return
      }

      DoHilightCheck

      ; ----------------------------------------------------
      ; If the person holds down shift and clicks. 
      ; Menu appears, and redraw highlight around selected
      ; square. Only does this if the person clicked on a
      ; date
      ; ----------------------------------------------------
      if ((%c.DayNum <= %c.DaysInMonth) && (%c.DayNum != 0)) {
        if ($calc($mouse.x + 90) >= 675) { set %CalMenu.menux $calc($mouse.x - 90) }
        else { set %CalMenu.menux $mouse.x }
        set %CalMenu.menuy $mouse.y
        set %CalMenu.datecreated %c.DayNum
        ReDrawWindow
        DoHilightCheck
        BuildMenu %CalMenu.menux %CalMenu.menuy
        drawdot @Calendar
      }
    }
  }
}

; -------------------
; End of mouse events
; -------------------
