
alias GetMonthName {
  if ($left($1,3) == Jan) { set %c.DaysInMonth 31 | set %c.NextMonth Feb | set %c.PrevMonth Dec | return January }
  elseif ($left($1,3) == Feb) { 
    set %c.NextMonth Mar
    set %c.PrevMonth Jan

    var %c.LeapYear1 $calc(%c.CurrentYear / 4)
    var %c.LeapYear2 $calc(%c.CurrentYear / 100)
    var %c.LeapYear3 $calc(%c.CurrentYear / 400)

    if ($gettok(%c.LeapYear3,2,46) == $null) { set %c.DaysInMonth 29 }
    elseif (($gettok(%c.LeapYear1,2,46) == $null) && ($gettok(%c.LeapYear2,2,46) == $null) && ($gettok(%c.LeapYear3,2,46) != $null)) { set %c.DaysInMonth 28 }
    elseif ($gettok(%c.LeapYear1,2,46) == $null) { set %c.DaysInMonth 29 }
    else { set %c.DaysInMonth 28 }
    return February
  }
  elseif ($left($1,3) == Mar) { set %c.DaysInMonth 31 | set %c.NextMonth Apr | set %c.PrevMonth Feb | return March }
  elseif ($left($1,3) == Apr) { set %c.DaysInMonth 30 | set %c.NextMonth May | set %c.PrevMonth Mar | return April }
  elseif ($left($1,3) == May) { set %c.DaysInMonth 31 | set %c.NextMonth Jun | set %c.PrevMonth Apr | return May }
  elseif ($left($1,3) == Jun) { set %c.DaysInMonth 30 | set %c.NextMonth Jul | set %c.PrevMonth May | return June }
  elseif ($left($1,3) == Jul) { set %c.DaysInMonth 31 | set %c.NextMonth Aug | set %c.PrevMonth Jun | return July }
  elseif ($left($1,3) == Aug) { set %c.DaysInMonth 31 | set %c.NextMonth Sep | set %c.PrevMonth Jul | return August }
  elseif ($left($1,3) == Sep) { set %c.DaysInMonth 30 | set %c.NextMonth Oct | set %c.PrevMonth Aug | return September }
  elseif ($left($1,3) == Oct) { set %c.DaysInMonth 31 | set %c.NextMonth Nov | set %c.PrevMonth Sep | return October }
  elseif ($left($1,3) == Nov) { set %c.DaysInMonth 30 | set %c.NextMonth Dec | set %c.PrevMonth Oct | return November }
  elseif ($left($1,3) == Dec) { set %c.DaysInMonth 31 | set %c.NextMonth Jan | set %c.PrevMonth Nov | return December }
}

; --------------------------------------------------------------------------------------------------
; Determine the day of the week for any given Month, Day, and Year.
; All input is given in the form of /DayOfWeek Month(1st 3 letters) Day Year(Fully 4 digit year)
; Use this by figuring out what month the person is looking at. Then input for the 1st day of that
; Month and use a loop to create squares for each day. Also includes blank squares for non-existant
; Days. As of now, it only works for any year from 2000-2099, but I doubt anyone will need anything
; More than that.
; --------------------------------------------------------------------------------------------------
alias DayOfWeek {
  var %c.Month $left($2,3)

  if ((%c.Month == Jan) || (%c.Month == Oct)) { var %c.AddMonth 1 }
  if ((%c.Month == Feb) || (%c.Month == Mar) || (%c.Month == Nov)) { var %c.AddMonth 4 }
  if ((%c.Month == Apr) || (%c.Month == Jul)) { var %c.AddMonth 0 }
  if (%c.Month == May) { var %c.AddMonth 2 }
  if (%c.Month == Jun) { var %c.AddMonth 5 }
  if (%c.Month == Aug) { var %c.AddMonth 3 }
  if ((%c.Month == Sep) || (%c.Month == Dec)) { var %c.AddMonth 6 }

  var %c.CurrentNum $calc($int($calc($right($3,-2) / 4)) + $1 + %c.AddMonth + 6 + $right($3,-2))

  while (%c.CurrentNum > 0) { var %c.CurrentNum $calc( %c.CurrentNum - 7) }

  set %c.DayOfWeekNum $calc(%c.CurrentNum + 7)
}
